untyped
global function pingDisplayPrecache

struct{
    bool changesColour = false //changes the RUI's colour based on the value of your ping
    vector position = Vector(0.0, 0.3, 0.0) //x axis: 0.0 is max left, 1.0 is max right; y axis: 0.0 is max top, 1.0 is max down; z doesn't do anything
    vector colour = Vector(1.0, 0.55, 0.0) //standard rgb format, range: min - 0.0 to max - 1.0
    float alpha = 0.7 //maxiumum alpha of the text, range: 0.0 to 1.0
    float size = 16.0 //size of the text
} settings

void function pingDisplayPrecache(){
    thread pingDisplayInit()
}

var pingDisplay = null

void function pingDisplayInit(){
    WaitFrame()
    pingDisplay = RuiCreate( $"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1 )
	RuiSetInt(pingDisplay, "maxLines", 1)
	RuiSetInt(pingDisplay, "lineNum", 1)
	RuiSetFloat2(pingDisplay, "msgPos", settings.position)
	RuiSetString(pingDisplay, "msgText", "ERROR :(")
	RuiSetFloat(pingDisplay, "msgFontSize", settings.size)
	RuiSetFloat(pingDisplay, "msgAlpha", 0.0)
	RuiSetFloat(pingDisplay, "thicken", 0.0)
	RuiSetFloat3(pingDisplay, "msgColor", settings.colour)
    thread pingDisplayMain()
}

void function pingDisplayMain(){
    while(true)
    {
        WaitFrame()
        if(!IsLobby() && !IsMenuLevel()){
            int ping = MyPing()
            string pingDis = "PING: " + format("%3i", ping)
            if(settings.changesColour){
                if(ping < 50)
                    RuiSetFloat3(pingDisplay, "msgColor", <0.0, 1.0, 0.0>)
                else if(ping < 100)
                    RuiSetFloat3(pingDisplay, "msgColor", <0.4, 1.0, 0.1>)
                else if(ping < 150)
                    RuiSetFloat3(pingDisplay, "msgColor", <1.0, 1.0, 0.5>)
                else if(ping < 200)
                    RuiSetFloat3(pingDisplay, "msgColor", <1.0, 0.4, 0.1>)
                else
                    RuiSetFloat3(pingDisplay, "msgColor", <1.0, 0.0, 0.0>)
                if(ping > 1000)
                    RuiSetFloat3(pingDisplay, "msgColor", <1.0, 0.0, 1.0>)
            }
            if(ping > 2000)
                pingDis += "(UH OH)"
            RuiSetString(pingDisplay, "msgText", pingDis)
            RuiSetFloat(pingDisplay, "msgAlpha", settings.alpha)
        }
        else
            RuiSetFloat(pingDisplay, "msgAlpha", 0.0)
    }
}